#include <stdio.h>
void say_hello_use_int(void *);
void say_hello_use_float(void *);
void say_hello(void (*)(void *), void *);

int main(void) {
    char ans;
    int i_name = 23;
    float f_name = 23.0;
    void *p;

    printf("Use int (i) or float (f)? ");
    scanf("%c", &ans);
    if (ans == 'i') {
        p = &i_name;
        say_hello(say_hello_use_int, p);
    }
    else {
        p = &f_name;
        say_hello(say_hello_use_float, p);
    }

    return 0;
}

void say_hello(void (*fp)(void *), void *q) {
  fp(q);
}

void say_hello_use_int(void *r) {
  int a;
  a = * (int *) r;  //get the value from the void pointer (after casting to int ptr)
  printf("Hello %d, you well rounded fellow!\n", a);
}

void say_hello_use_float(void *s) {
  float *b;
  b = (float *) s;  //typecast the void pointer to a float pointer
  printf("Hello %f, you float!\n", *b);
}






